program exercise5
  implicit none
  double precision, dimension(1:3) :: a, b
  integer :: i
  double precision :: sum, innerprod, abs_a, abs_b

  ! 配列aとbに初期値を代入
  a(1) = 0.0d0; a(2) = 1.0d0/sqrt(2.0d0); a(3) = 1.0d0
  b(1) = 2.0d0; b(2) = sqrt(2.0d0); b(3) = -1.0d0

  ! aとbの和を計算して出力
  print *, "sum" 
  do i = 1, 3
     print *, a(i)+b(i) !和は成分ごとに計算
  end do

  ! 内積を計算
  print *, "inner product"
  innerprod = 0.0d0  ! doループを回す前に初期値を代入
  do i = 1, 3
     innerprod = innerprod + a(i)*b(i)
  end do
  print *, "a dot b = ", innerprod

  print *, dot_product(a, b) !内積は組み込み関数でも計算できる

  ! 絶対値の計算
  print *, "absolute value"
  abs_a = 0.0d0
  abs_b = 0.0d0 ! doループを回す前に初期値を代入
  do i = 1, 3
     abs_a = abs_a + a(i)**2
     abs_b = abs_b + b(i)**2
  end do

  print *, "|a| = ", sqrt(abs_a), "|b| = ", sqrt(abs_b)
  

end program exercise5
